Index: /trunk/gsdl/perllib/plugins/ImagePlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/ImagePlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/ImagePlug.pm	(revision 10218)
@@ -46,4 +46,5 @@
 	'type' => "int",
 	'deft' => "100",
+	'range' => "1,",
 	'reqd' => "no" },
       { 'name' => "thumbnailtype",
@@ -56,4 +57,5 @@
 	'type' => "int",
 	'deft' => "0",
+	'range' => "1,",
 	'reqd' => "no" },
       { 'name' => "screenviewtype",
@@ -71,4 +73,5 @@
 	'type' => "int",
 	'deft' => "100",
+	'range' => "1,",
 	'reqd' => "no" } ];
 
@@ -82,28 +85,12 @@
 
 sub new {
-    my ($class) = @_;
-    my $plugin_name = shift (@_);
-    my $self = new BasPlug ("ImagePlug", @_);
-    $self->{'plugin_type'} = "ImagePlug";
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
-
-    if (!parsargv::parse(\@_,
-			 q^noscaleup^, \$self->{'noscaleup'},
-			 q^converttotype/.*/^, \$self->{'converttotype'},
-			 q^minimumsize/[0-9]*/100^, \$self->{'minimumsize'},
-
-			 q^thumbnailsize/[0-9]*/100^, \$self->{'thumbnailsize'},
-			 q^thumbnailtype/.*/gif^, \$self->{'thumbnailtype'},
-			 q^screenviewsize/[0-9]*/0^, \$self->{'screenviewsize'},
-			 q^screenviewtype/.*/jpg^, \$self->{'screenviewtype'},
-			 "allow_extra_options")) {
-	
-	print STDERR "\nImagePlug uses an incorrect option.\n";
-	print STDERR "Check your collect.cfg configuration file.\n";
-	$self->print_txt_usage("");  # Use default resource bundle
-	die "\n";
-    }
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new BasPlug($pluginlist,$inputargs,$hashArgOptLists): new BasPlug($pluginlist,$inputargs);
 
     # Check that ImageMagick is installed and available on the path (except for Windows 95/98)
Index: /trunk/gsdl/perllib/plugins/IndexPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/IndexPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/IndexPlug.pm	(revision 10218)
@@ -70,9 +70,12 @@
 
 sub new {
-    my ($class) = @_;
-    my $self = new BasPlug ("IndexPlug", @_);
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new BasPlug($pluginlist,$inputargs,$hashArgOptLists): new BasPlug($pluginlist,$inputargs);
 
     return bless $self, $class;
Index: /trunk/gsdl/perllib/plugins/LaTeXPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/LaTeXPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/LaTeXPlug.pm	(revision 10218)
@@ -28,6 +28,7 @@
 package LaTeXPlug;
 
-use strict;
-no strict 'refs'; # so we can print to a handle named by a variable
+# System complains about $arguments if the strict is set
+#use strict;
+#no strict 'refs'; # so we can print to a handle named by a variable
 
 # greenstone packages
@@ -37,4 +38,8 @@
 use util;
 
+my $options={ 'name' => 'LaTeXPlug',
+	      'desc' => '{LaTeXPlug.desc}',
+	      'abstract' => 'no',
+	      'inherits' => 'yes' };
 sub BEGIN {
     @LaTeXPlug::ISA = ('BasPlug');
@@ -46,25 +51,12 @@
 
 sub new {
-    my $class = shift (@_);
-    my $self = new BasPlug ($class, @_);
-    $self->{'plugin_type'} = 'LaTeXPlug';
-    my $option_list = $self->{'option_list'};
-    my $options={ 'name' => 'LaTeXPlug',
-		  'desc' => '{LaTeXPlug.desc}',
-		  'abstract' => 'no',
-		  'inherits' => 'yes',
-		  'args' => [
-			     ] # no arguments for now...
-			     };
-
-    push( @{$option_list}, $options );
-
-    if (!parsargv::parse(\@_, 
-			 "allow_extra_options")) {
-
-	print STDERR "\nIncorrect options passed to LaTeXPlug, check your collect.cfg configuration file\n";
-	$self->print_txt_usage(""); # don't specify which language bundle
-	die "\n";
-    }
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new BasPlug($pluginlist,$inputargs,$hashArgOptLists): new BasPlug($pluginlist,$inputargs);
 
     $self->{'aux_files'} = {};
Index: /trunk/gsdl/perllib/plugins/MACROPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/MACROPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/MACROPlug.pm	(revision 10218)
@@ -85,10 +85,12 @@
 
 sub new {
-    my ($class) = @_;
-    my $self = new BasPlug ($class, @_);
-
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new BasPlug($pluginlist,$inputargs,$hashArgOptLists): new BasPlug($pluginlist,$inputargs);
 
     # $self->{'lang_abbr'} = load_language_table();
Index: /trunk/gsdl/perllib/plugins/MARCPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/MARCPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/MARCPlug.pm	(revision 10218)
@@ -69,24 +69,12 @@
 
 sub new {
-    my $class = shift (@_);
-    my $self = new SplitPlug ($class, @_);
-    $self->{'plugin_type'} = "MARCPlug";
-    my $metadata_mapping;
-
-    if (!parsargv::parse(\@_, 
-			 q^metadata_mapping/.*/marctodc.txt^, \$metadata_mapping,
-			 "allow_extra_options")) {
-
-	print STDERR "\nIncorrect options passed to MARCPlug, check your collect.cfg configuration file\n";
-	$self->print_txt_usage("");  # Use default resource bundle
-	die "\n";
-    }
-
-
-    $self->{'mm_file'} = $metadata_mapping; # relative to etc dir
-
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new SplitPlug($pluginlist,$inputargs,$hashArgOptLists): new SplitPlug($pluginlist,$inputargs);
 
     return bless $self, $class;
@@ -101,5 +89,5 @@
     # read in the metadata mapping file
     my $mm_file =
-	&util::filename_cat( $ENV{'GSDLHOME'}, "etc", $self->{'mm_file'} );
+	&util::filename_cat( $ENV{'GSDLHOME'}, "etc", $self->{'metadata_mapping'} );
 
     if (!-e $mm_file)
@@ -107,10 +95,10 @@
 
 	my $msg = "MARCPlug ERROR: Can't locate mapping file \"" .
-	    $self->{'mm_file'} . "\".\n    This file should be at $mm_file\n" .
+	    $self->{'metadata_mapping'} . "\".\n    This file should be at $mm_file\n" .
 		"    No marc files can be processed.\n";
 
 	print $outhandle $msg;
 	print $failhandle $msg;
-	$self->{'mm_file'} = undef;
+	$self->{'metadata_mapping'} = undef;
 	# We pick up the error in process() if there is no $mm_file
 	# If we exit here, then pluginfo.pl will exit too!
@@ -222,5 +210,5 @@
     my $filename = &util::filename_cat($base_dir, $file);
 
-    if (! defined($self->{'mm_file'}))
+    if (! defined($self->{'metadata_mapping'}))
     {
 	print $outhandle "MARCPlug: no metadata file! Can't process $file\n";
Index: /trunk/gsdl/perllib/plugins/METSPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/METSPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/METSPlug.pm	(revision 10218)
@@ -40,5 +40,5 @@
 
 sub BEGIN {
-    @ISA = ('XMLPlug');
+    @METSPlug::ISA = ('XMLPlug');
 }
 
@@ -56,10 +56,12 @@
 
 sub new {
-    my $class = shift (@_);
-    my $self = new XMLPlug ($class, @_);
-
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new XMLPlug($pluginlist,$inputargs,$hashArgOptLists): new XMLPlug($pluginlist,$inputargs);
 
     $self->{'section'} = "";
Index: /trunk/gsdl/perllib/plugins/MP3Plug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/MP3Plug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/MP3Plug.pm	(revision 10218)
@@ -66,20 +66,12 @@
 
 sub new {
-    my ($class) = @_;
-    my $self = new UnknownPlug ($class, @_);
-    $self->{'plugin_type'} = "MP3Plug";
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
-
-    if (!parsargv::parse(\@_, 
-			 q^assoc_images^, \$self->{'assoc_images'},
-			 q^applet_metadata^, \$self->{'applet_metadata'},
-			 q^metadata_fields/.*/Title,Artist,Genre^, \$self->{'metadata_fields'},
-			 "allow_extra_options")) {
-	print STDERR "\nIncorrect options passed to MP3Plug, check your collect.cfg configuration file\n";
-	$self->print_txt_usage("");  # Use default resource bundle
-        die "\n";
-    }
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new UnknownPlug($pluginlist,$inputargs,$hashArgOptLists): new UnknownPlug($pluginlist,$inputargs);
 
     return bless $self, $class;
Index: /trunk/gsdl/perllib/plugins/NULPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/NULPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/NULPlug.pm	(revision 10218)
@@ -57,19 +57,13 @@
 
 sub new {
-    my ($class) = @_;
-    my $self = new BasPlug ($class, @_);
-    $self->{'plugin_type'} = "NULPlug";
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
 
-    if (!parsargv::parse(\@_, 
-			 "allow_extra_options")) {
-	print STDERR "\nIncorrect options passed to NULPlug, check your collect.cfg configuration file\n";
-	$self->print_txt_usage("");  # Use default resource bundle
-        die "\n";
-    }
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
 
-
+    my $self = (defined $hashArgOptLists)? new BasPlug($pluginlist,$inputargs,$hashArgOptLists): new BasPlug($pluginlist,$inputargs);
+    
     return bless $self, $class;
 }
Index: /trunk/gsdl/perllib/plugins/OAIPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/OAIPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/OAIPlug.pm	(revision 10218)
@@ -54,18 +54,12 @@
 
 sub new {
-    my $class = shift (@_);
-    my $self = new XMLPlug ($class, @_);
-    $self->{'plugin_type'} = "OAIPlug";
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
-
-    if (!parsargv::parse(\@_, 
-			 "allow_extra_options")) {
-
-	print STDERR "\nIncorrect options passed to OAIPlug, check your collect.cfg configuration file\n";
-	$self->print_txt_usage("");  # Use default resource bundle
-	die "\n";
-    }
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new XMLPlug($pluginlist,$inputargs,$hashArgOptLists): new XMLPlug($pluginlist,$inputargs);
 
     return bless $self, $class;
Index: /trunk/gsdl/perllib/plugins/OggVorbisPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/OggVorbisPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/OggVorbisPlug.pm	(revision 10218)
@@ -35,5 +35,5 @@
 
 sub BEGIN {
-    @ISA = ('UnknownPlug');
+    @OggVorbisPlug::ISA = ('UnknownPlug');
 }
 
@@ -65,19 +65,13 @@
 sub new
 {
-    my $class = shift(@_);
-
-    my $self = new UnknownPlug($class, @_);
-    $self->{'plugin_type'} = "OggVorbisPlug";
-
-    if (!parsargv::parse(\@_,
-			 q^add_technical_metadata^, \$self->{'add_technical_metadata'},
-			 "allow_extra_options")) {
-	die "\nIncorrect options passed to OggVorbisPlug, check your collect.cfg configuration file\n";
-    }
-
-    # To allow for proper inheritance of arguments
-    my $option_list = $self->{'option_list'};
-    push(@{$option_list}, $options);
-
+    my ($class) = shift(@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+    
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+    
+    my $self = (defined $hashArgOptLists)? new UnknownPlug($pluginlist,$inputargs,$hashArgOptLists): new UnknownPlug($pluginlist,$inputargs);
+    
     return bless $self, $class;
 }
Index: /trunk/gsdl/perllib/plugins/PDFPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/PDFPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/PDFPlug.pm	(revision 10218)
@@ -70,49 +70,27 @@
 
 sub new {
-    my $class = shift (@_);
-
-    my ($noimages, $complex, $zoom, $use_sections, $nohidden);
-
-    my @args=@_;
-
-    if (!parsargv::parse(\@_, 
-			 q^noimages^, \$noimages,
-			 q^complex^, \$complex,
-			 q^zoom/\d+/2^, \$zoom,
-			 q^nohidden^, \$nohidden,
-			 q^use_sections^, \$use_sections,
-			 "allow_extra_options")) {
-
-	my $self = new ConvertToPlug($class, @_);
-	my $outhandle=$self->{'outhandle'};
-	print $outhandle "\nIncorrect options passed to PDFPlug, check your collect.cfg configuration file\n";
-	$self->print_txt_usage("");  # Use default resource bundle
-	exit 1;
-    }
-
-
-    if ($use_sections) {
-	push (@args, "-description_tags");
-    }
-
-    # following title_sub removes "Page 1" added by pdftohtml, and a leading
-    # "1", which is often the page number at the top of the page. Bad Luck
-    # if your document title actually starts with "1 " - is there a better way?
-
-    my $self = new ConvertToPlug ($class, @args, "-title_sub", '^(Page\s+\d+)?(\s*1\s+)?');
-    $self->{'plugin_type'} = "PDFPlug";
-    if ($use_sections) {
-	$self->{'use_sections'}=1;
-    }
-
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    push(@$inputargs,"-title_sub");
+    push(@$inputargs,'^(Page\s+\d+)?(\s*1\s+)?');
+
+    my $self = (defined $hashArgOptLists)? new ConvertToPlug($pluginlist,$inputargs,$hashArgOptLists): new ConvertToPlug($pluginlist,$inputargs);
+
+
+    if ($self->{"use_sections"}) {
+	$self->{"description_tags"} = 1;
+    }
 
     # these are passed through to gsConvert.pl by ConvertToPlug.pm
+    my $zoom = $self->{"zoom"};
     $self->{'convert_options'} = "-pdf_zoom $zoom";
-    $self->{'convert_options'} .= " -pdf_complex" if $complex;
-    $self->{'convert_options'} .= " -pdf_nohidden" if $nohidden;
-    $self->{'convert_options'} .= " -pdf_ignore_images" if $noimages;
+    $self->{'convert_options'} .= " -pdf_complex" if $self->{"complex"};
+    $self->{'convert_options'} .= " -pdf_nohidden" if $self->{"nohidden"};
+    $self->{'convert_options'} .= " -pdf_ignore_images" if $self->{"noimages"};
 
     # pdftohtml will always produce html files encoded as utf-8
Index: /trunk/gsdl/perllib/plugins/PPTPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/PPTPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/PPTPlug.pm	(revision 10218)
@@ -49,16 +49,17 @@
 
 sub new {
-    my $class = shift (@_);
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
 
-    my $self = new ConvertToPlug ($class, @_);
-    $self->{'plugin_type'} = "PPTPlug";
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new ConvertToPlug($pluginlist,$inputargs,$hashArgOptLists): new ConvertToPlug($pluginlist,$inputargs);
+
     # ppthtml outputs utf-8 already.
     if ($self->{'input_encoding'} eq "auto") {
 	$self->{'input_encoding'} = "utf8";
     }
-
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
 
     return bless $self, $class;
Index: /trunk/gsdl/perllib/plugins/PSPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/PSPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/PSPlug.pm	(revision 10218)
@@ -62,23 +62,17 @@
 
 sub new {
-    my $class = shift (@_);
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
 
-    # title_sub removes leading "Page 1" or "1 " from auto-extracted title.
+    push(@$inputargs,"-convert_to");
+    push(@$inputargs,"text");
+    push(@$inputargs,"-title_sub");
+    push(@$inputargs,'^(Page\s+\d+)?(\s*1\s+)?');
 
-    my $self = new ConvertToPlug ($class, "-convert_to", "text", @_ , "-title_sub", '^(Page\s+\d+)?(\s*1\s+)?');
-    $self->{'plugin_type'} = "PSPlug";
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
-    
-    if (!parsargv::parse(\@_, 
-			 q^extract_date^, \$self->{'extract_date'},
-			 q^extract_pages^, \$self->{'extract_pages'},
-			 q^extract_title^, \$self->{'extract_title'},
-			 "allow_extra_options")) {
-	print STDERR "\nIncorrect options passed to HTMLPlug, check your collect.cfg configuration file\n";
-	$self->print_txt_usage("");  # Use default resource bundle
-	die "\n";
-    }
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new ConvertToPlug($pluginlist,$inputargs,$hashArgOptLists): new ConvertToPlug($pluginlist,$inputargs);
 
     return bless $self, $class;
Index: /trunk/gsdl/perllib/plugins/PagedImgPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/PagedImgPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/PagedImgPlug.pm	(revision 10218)
@@ -137,5 +137,5 @@
 
 sub BEGIN {
-    @ISA = ('XMLPlug');
+    @PagedImgPlug::ISA = ('XMLPlug');
 }
 
@@ -220,31 +220,12 @@
 
 sub new {
-    my ($class) = @_;
-    my $plugin_name = shift (@_);
-    $self = new XMLPlug ("PagedImgPlug", @_);
-
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
-
-    if (!parsargv::parse(\@_,
-			 q^noscaleup^, \$self->{'noscaleup'},
-			 q^converttotype/.*/^, \$self->{'converttotype'},
-			 q^minimumsize/[0-9]*/100^, \$self->{'minimumsize'},
-
-			 q^thumbnailsize/[0-9]*/100^, \$self->{'thumbnailsize'},
-			 q^thumbnailtype/.*/gif^, \$self->{'thumbnailtype'},
-			 q^screenviewsize/[0-9]*/0^, \$self->{'screenviewsize'},
-			 q^screenviewtype/.*/jpg^, \$self->{'screenviewtype'},
-			 q^thumbnail^, \$self->{'thumbnail'},
-			 q^screenview^, \$self->{'screenview'},
-			 q^headerpage^, \$self->{'headerpage'},
-			 'documenttype/^(paged|hierarchy)$/paged', \$self->{'doctype'},
-			 "allow_extra_options")) {
-	
-	print STDERR "\nPagedImgPlug uses an incorrect option.\n";
-	print STDERR "Check your collect.cfg configuration file.\n";
-	$self->print_txt_usage("");  # Use default resource bundle
-	die "\n";
-    }
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new XMLPlug($pluginlist,$inputargs,$hashArgOptLists): new XMLPlug($pluginlist,$inputargs);
 
     return bless $self, $class;
@@ -768,5 +749,5 @@
     $self->{'num_pages'} = 0;
     my $topsection = $doc_obj->get_top_section();
-    if ($self->{'doctype'} eq 'paged') {
+    if ($self->{'documenttype'} eq 'paged') {
 	# set the gsdlthistype metadata to Paged - this ensures this document will
 	# be treated as a Paged doc, even if Titles are not numeric
@@ -806,5 +787,5 @@
     my $topsection = $doc_obj->get_top_section();
 
-    if ($self->{'doctype'} eq 'paged') {
+    if ($self->{'documenttype'} eq 'paged') {
 	# set the gsdlthistype metadata to Paged - this ensures this document will
 	# be treated as a Paged doc, even if Titles are not numeric
Index: /trunk/gsdl/perllib/plugins/ProCitePlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/ProCitePlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/ProCitePlug.pm	(revision 10218)
@@ -74,16 +74,12 @@
 sub new
 {
-    my $class = shift(@_);
-
-    my $self = new SplitPlug($class, @_);
-    if (!parsargv::parse(\@_,
-			 "allow_extra_options")) {
-	die "\nIncorrect options passed to ProCitePlug, check your collect.cfg configuration file\n";
-    }
-
-    # To allow for proper inheritance of arguments
-    my $option_list = $self->{'option_list'};
-    push(@{$option_list}, $options);
-    $self->{'plugin_type'} = "ProCitePlug";
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new SplitPlug($pluginlist,$inputargs,$hashArgOptLists): new SplitPlug($pluginlist,$inputargs);
 
     return bless $self, $class;
Index: /trunk/gsdl/perllib/plugins/RTFPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/RTFPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/RTFPlug.pm	(revision 10218)
@@ -49,10 +49,12 @@
 
 sub new {
-    my $class = shift (@_);
-    my $self = new ConvertToPlug ($class, @_);
-    $self->{'plugin_type'}="RTFPlug";
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new ConvertToPlug($pluginlist,$inputargs,$hashArgOptLists): new ConvertToPlug($pluginlist,$inputargs);
 
     return bless $self, $class;
Index: /trunk/gsdl/perllib/plugins/RecPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/RecPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/RecPlug.pm	(revision 10218)
@@ -131,24 +131,14 @@
 
 my ($self);
+
 sub new {
-    my $class = shift (@_);
-    
-    # $self is global for use within subroutines called by XML::Parser
-    $self = new BasPlug ($class, @_);
-    
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
-
-    if (!parsargv::parse(\@_,
-			 q^use_metadata_files^, \$self->{'use_metadata_files'},
-			 q^recheck_directories^, \$self->{'recheck_directories'},
-			 "allow_extra_options")) {
-	print STDERR "\nRecPlug uses an incorrect option.\n";
-	print STDERR "Check your collect.cfg configuration file.\n\n";
-	$self->print_txt_usage("");  # Use default resource bundle
-	die "\n";
-    }
-    
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    $self = (defined $hashArgOptLists)? new BasPlug($pluginlist,$inputargs,$hashArgOptLists): new BasPlug($pluginlist,$inputargs);
     if ($self->{'use_metadata_files'}) {
 	# create XML::Parser object for parsing metadata.xml files
@@ -157,8 +147,9 @@
 						    'Doctype' => \&Doctype
 						    });
+
 	$self->{'parser'} = $parser;
 	$self->{'in_filename'} = 0;
     }
-
+    
     $self->{'subdir_extrametakeys'} = {};
 
@@ -425,4 +416,5 @@
 	# Next add metadata read in XML files (if it is supplied)
 	if ($additionalmetadata == 1) {
+	    
 	    my ($filespec, $mdref);
 	    foreach $filespec (@extrametakeys) {
@@ -498,5 +490,5 @@
 sub StartTag {
     my ($expat, $element) = @_;
-    
+
     if ($element eq "FileSet") {
 	$self->{'saved_targets'} = [];
Index: /trunk/gsdl/perllib/plugins/ReferPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/ReferPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/ReferPlug.pm	(revision 10218)
@@ -102,10 +102,12 @@
 
 sub new {
-    my $class = shift (@_);
-    my $self = new SplitPlug ($class, @_);
-    $self->{'plugin_type'} = "ReferPlug";
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new SplitPlug($pluginlist,$inputargs,$hashArgOptLists): new SplitPlug($pluginlist,$inputargs);
 
     return bless $self, $class;
Index: /trunk/gsdl/perllib/plugins/RogPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/RogPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/RogPlug.pm	(revision 10218)
@@ -51,10 +51,12 @@
 
 sub new {
-    my ($class) = @_;
-    $self = new BasPlug ();
-    $self->{'plugin_type'} = "RogPlug";
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new BasPlug($pluginlist,$inputargs,$hashArgOptLists): new BasPlug($pluginlist,$inputargs);
 
     return bless $self, $class;
Index: /trunk/gsdl/perllib/plugins/SRCPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/SRCPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/SRCPlug.pm	(revision 10218)
@@ -71,21 +71,13 @@
 
 sub new {
-    my ($class) = @_;
-    my $self = new BasPlug ($class, @_);
-    $self->{'plugin_type'} = "SRCPlug";
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
-
-    if (!parsargv::parse(\@_,
-			 q^remove_prefix/(\S+)/^, \$self->{'remove_prefix'},
-			 "allow_extra_options"
-			 )
-	) {
-        print STDERR "\nIncorrect options passed to SRCPlug, ";
-        print STDERR "check your collect.cfg configuration file\n";
-	$self->print_txt_usage("");  # Use default resource bundle
-        die "\n";
-    }
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new BasPlug($pluginlist,$inputargs,$hashArgOptLists): new BasPlug($pluginlist,$inputargs);
+
     return bless $self, $class;
 }
Index: /trunk/gsdl/perllib/plugins/SplitPlug.pm
===================================================================
--- /trunk/gsdl/perllib/plugins/SplitPlug.pm	(revision 10217)
+++ /trunk/gsdl/perllib/plugins/SplitPlug.pm	(revision 10218)
@@ -54,5 +54,6 @@
 	'desc' => "{SplitPlug.split_exp}",
 	'type' => "regexp",
-	'deft' => &get_default_split_exp(),
+	#'deft' => &get_default_split_exp(),
+	'deft' => "",
 	'reqd' => "no" } ];
 
@@ -65,20 +66,12 @@
 
 sub new {
-    my ($class) = @_;
-    $self = new BasPlug($class, @_);
-
-    $self->{'plugin_type'} = "SplitPlug";
-    
-    # 14-05-02 To allow for proper inheritance of arguments - John Thompson
-    my $option_list = $self->{'option_list'};
-    push( @{$option_list}, $options );
-    
-    if (!parsargv::parse(\@_, 
-			 q^split_exp/.*/^, \$self->{'split_exp'},
-			 "allow_extra_options")) {
-	print STDERR "\nIncorrect options passed to $class.";
-	print STDERR "\nCheck your collect.cfg configuration file\n";
-	die "\n";
-    }
+    my ($class) = shift (@_);
+    my ($pluginlist,$inputargs,$hashArgOptLists) = @_;
+    push(@$pluginlist, $class);
+
+    if(defined $arguments){ push(@{$hashArgOptLists->{"ArgList"}},@{$arguments});}
+    if(defined $options) { push(@{$hashArgOptLists->{"OptList"}},$options)};
+
+    my $self = (defined $hashArgOptLists)? new BasPlug($pluginlist,$inputargs,$hashArgOptLists): new BasPlug($pluginlist,$inputargs);
 
     $self->{'textcat_store'} = {};
